org.jboss.netty.channel

## Interface ChannelFuture

- All Known Implementing Classes:
    ChannelRunnableWrapper, CompleteChannelFuture, DefaultChannelFuture, FailedChannelFuture, SucceededChannelFuture

      public interface ChannelFuture

  The result of an asynchronous `Channel` I/O operation.

  All I/O operations in Netty are asynchronous. It means any I/O calls will return immediately with no guarantee that the requested I/O operation has been completed at the end of the call. Instead, you will be returned with a `ChannelFuture` instance which gives you the information about the result or status of the I/O operation.

  A `ChannelFuture` is either uncompleted or completed. When an I/O operation begins, a new future object is created. The new future is uncompleted initially - it is neither succeeded, failed, nor cancelled because the I/O operation is not finished yet. If the I/O operation is finished either successfully, with failure, or by cancellation, the future is marked as completed with more specific information, such as the cause of the failure. Please note that even failure and cancellation belong to the completed state.

                                            +---------------------------+
                                            | Completed successfully    |
                                            +---------------------------+
                                       +---->      isDone() = true      |
       +--------------------------+    |    |   isSuccess() = true      |
       |        Uncompleted       |    |    +===========================+
       +--------------------------+    |    | Completed with failure    |
       |      isDone() = false    |    |    +---------------------------+
       |   isSuccess() = false    |----+---->   isDone() = true         |
       | isCancelled() = false    |    |    | getCause() = non-null     |
       |    getCause() = null     |    |    +===========================+
       +--------------------------+    |    | Completed by cancellation |
                                       |    +---------------------------+
                                       +---->      isDone() = true      |
                                            | isCancelled() = true      |
                                            +---------------------------+

  Various methods are provided to let you check if the I/O operation has been completed, wait for the completion, and retrieve the result of the I/O operation. It also allows you to add `ChannelFutureListener`s so you can get notified when the I/O operation is completed.

  ### Prefer `addListener(ChannelFutureListener)` to `await()`

  It is recommended to prefer `addListener(ChannelFutureListener)` to `await()` wherever possible to get notified when an I/O operation is done and to do any follow-up tasks.

  `addListener(ChannelFutureListener)` is non-blocking. It simply adds the specified `ChannelFutureListener` to the `ChannelFuture`, and I/O thread will notify the listeners when the I/O operation associated with the future is done. `ChannelFutureListener` yields the best performance and resource utilization because it does not block at all, but it could be tricky to implement a sequential logic if you are not used to event-driven programming.

  By contrast, `await()` is a blocking operation. Once called, the caller thread blocks until the operation is done. It is easier to implement a sequential logic with `await()`, but the caller thread blocks unnecessarily until the I/O operation is done and there's relatively expensive cost of inter-thread notification. Moreover, there's a chance of dead lock in a particular circumstance, which is described below.

  ### Do not call `await()` inside `ChannelHandler`

  The event handler methods in `ChannelHandler` is often called by an I/O thread unless an `ExecutionHandler` is in the `ChannelPipeline`. If `await()` is called by an event handler method, which is called by the I/O thread, the I/O operation it is waiting for might never be complete because `await()` can block the I/O operation it is waiting for, which is a dead lock.

       // BAD - NEVER DO THIS
       @Override
       public void messageReceived(ChannelHandlerContext ctx, MessageEvent e) {
           if (e.getMessage() instanceof GoodByeMessage) {
               ChannelFuture future = e.getChannel().close();
               future.awaitUninterruptibly();
               // Perform post-closure operation
               // ...
           }
       }

       // GOOD
       @Override
       public void messageReceived(ChannelHandlerContext ctx, MessageEvent e) {
           if (e.getMessage() instanceof GoodByeMessage) {
               ChannelFuture future = e.getChannel().close();
               future.addListener(new ChannelFutureListener() {
                   public void operationComplete(ChannelFuture future) {
                       // Perform post-closure operation
                       // ...
                   }
               });
           }
       }

  In spite of the disadvantages mentioned above, there are certainly the cases where it is more convenient to call `await()`. In such a case, please make sure you do not call `await()` in an I/O thread. Otherwise, `IllegalStateException` will be raised to prevent a dead lock.

  ### Do not confuse I/O timeout and await timeout

  The timeout value you specify with `await(long)`, `await(long, TimeUnit)`, `awaitUninterruptibly(long)`, or `awaitUninterruptibly(long, TimeUnit)` are not related with I/O timeout at all. If an I/O operation times out, the future will be marked as 'completed with failure,' as depicted in the diagram above. For example, connect timeout should be configured via a transport-specific option:

       // BAD - NEVER DO THIS
       ClientBootstrap b = ...;
       ChannelFuture f = b.connect(...);
       f.awaitUninterruptibly(10, TimeUnit.SECONDS);
       if (f.isCancelled()) {
           // Connection attempt cancelled by user
       } else if (!f.isSuccess()) {
           // You might get a NullPointerException here because the future
           // might not be completed yet.
           f.getCause().printStackTrace();
       } else {
           // Connection established successfully
       }

       // GOOD
       ClientBootstrap b = ...;
       // Configure the connect timeout option.
       b.setOption("connectTimeoutMillis", 10000);
       ChannelFuture f = b.connect(...);
       f.awaitUninterruptibly();

       // Now we are sure the future is completed.
       assert f.isDone();

       if (f.isCancelled()) {
           // Connection attempt cancelled by user
       } else if (!f.isSuccess()) {
           f.getCause().printStackTrace();
       } else {
           // Connection established successfully
       }

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addListener(ChannelFutureListener listener)` Adds the specified listener to this future.
    `ChannelFuture` | `await()` Waits for this future to be completed.
    `boolean` | `await(long timeoutMillis)` Waits for this future to be completed within the specified time limit.
    `boolean` | `await(long timeout, TimeUnit unit)` Waits for this future to be completed within the specified time limit.
    `ChannelFuture` | `awaitUninterruptibly()` Waits for this future to be completed without interruption.
    `boolean` | `awaitUninterruptibly(long timeoutMillis)` Waits for this future to be completed within the specified time limit without interruption.
    `boolean` | `awaitUninterruptibly(long timeout, TimeUnit unit)` Waits for this future to be completed within the specified time limit without interruption.
    `boolean` | `cancel()` Cancels the I/O operation associated with this future and notifies all listeners if canceled successfully.
    `Throwable` | `getCause()` Returns the cause of the failed I/O operation if the I/O operation has failed.
    `Channel` | `getChannel()` Returns a channel where the I/O operation associated with this future takes place.
    `boolean` | `isCancelled()` Returns `true` if and only if this future was cancelled by a `cancel()` method.
    `boolean` | `isDone()` Returns `true` if and only if this future is complete, regardless of whether the operation was successful, failed, or cancelled.
    `boolean` | `isSuccess()` Returns `true` if and only if the I/O operation was completed successfully.
    `void` | `removeListener(ChannelFutureListener listener)` Removes the specified listener from this future.
    `ChannelFuture` | `rethrowIfFailed()` Deprecated. Use `sync()` or `syncUninterruptibly()` instead.
    `boolean` | `setFailure(Throwable cause)` Marks this future as a failure and notifies all listeners.
    `boolean` | `setProgress(long amount, long current, long total)` Notifies the progress of the operation to the listeners that implements `ChannelFutureProgressListener`.
    `boolean` | `setSuccess()` Marks this future as a success and notifies all listeners.
    `ChannelFuture` | `sync()` Waits for this future until it is done, and rethrows the cause of the failure if this future failed.
    `ChannelFuture` | `syncUninterruptibly()` Waits for this future until it is done, and rethrows the cause of the failure if this future failed.

- - ### Method Detail

    - #### getChannel

          Channel getChannel()

      Returns a channel where the I/O operation associated with this future takes place.

    - #### isDone

          boolean isDone()

      Returns `true` if and only if this future is complete, regardless of whether the operation was successful, failed, or cancelled.

    - #### isCancelled

          boolean isCancelled()

      Returns `true` if and only if this future was cancelled by a `cancel()` method.

    - #### isSuccess

          boolean isSuccess()

      Returns `true` if and only if the I/O operation was completed successfully.

    - #### getCause

          Throwable getCause()

      Returns the cause of the failed I/O operation if the I/O operation has failed.
      Returns:
        the cause of the failure. `null` if succeeded or this future is not completed yet.

    - #### cancel

          boolean cancel()

      Cancels the I/O operation associated with this future and notifies all listeners if canceled successfully.
      Returns:
        `true` if and only if the operation has been canceled. `false` if the operation can't be canceled or is already completed.

    - #### setSuccess

          boolean setSuccess()

      Marks this future as a success and notifies all listeners.
      Returns:
        `true` if and only if successfully marked this future as a success. Otherwise `false` because this future is already marked as either a success or a failure.

    - #### setFailure

          boolean setFailure(Throwable cause)

      Marks this future as a failure and notifies all listeners.
      Returns:
        `true` if and only if successfully marked this future as a failure. Otherwise `false` because this future is already marked as either a success or a failure.

    - #### setProgress

          boolean setProgress(long amount,
                            long current,
                            long total)

      Notifies the progress of the operation to the listeners that implements `ChannelFutureProgressListener`. Please note that this method will not do anything and return `false` if this future is complete already.
      Returns:
        `true` if and only if notification was made.

    - #### addListener

          void addListener(ChannelFutureListener listener)

      Adds the specified listener to this future. The specified listener is notified when this future is done. If this future is already completed, the specified listener is notified immediately.

    - #### removeListener

          void removeListener(ChannelFutureListener listener)

      Removes the specified listener from this future. The specified listener is no longer notified when this future is done. If the specified listener is not associated with this future, this method does nothing and returns silently.

    - #### rethrowIfFailed

          @Deprecated
          ChannelFuture rethrowIfFailed()
                                        throws Exception

      Deprecated. Use `sync()` or `syncUninterruptibly()` instead.
      Throws:
        `Exception`

    - #### sync

          ChannelFuture sync()
                             throws InterruptedException

      Waits for this future until it is done, and rethrows the cause of the failure if this future failed. If the cause of the failure is a checked exception, it is wrapped with a new `ChannelException` before being thrown.
      Throws:
        `InterruptedException`

    - #### syncUninterruptibly

          ChannelFuture syncUninterruptibly()

      Waits for this future until it is done, and rethrows the cause of the failure if this future failed. If the cause of the failure is a checked exception, it is wrapped with a new `ChannelException` before being thrown.

    - #### await

          ChannelFuture await()
                              throws InterruptedException

      Waits for this future to be completed.
      Throws:
        `InterruptedException` - if the current thread was interrupted

    - #### awaitUninterruptibly

          ChannelFuture awaitUninterruptibly()

      Waits for this future to be completed without interruption. This method catches an `InterruptedException` and discards it silently.

    - #### await

          boolean await(long timeout,
                      TimeUnit unit)
                        throws InterruptedException

      Waits for this future to be completed within the specified time limit.
      Returns:
        `true` if and only if the future was completed within the specified time limit
      Throws:
        `InterruptedException` - if the current thread was interrupted

    - #### await

          boolean await(long timeoutMillis)
                        throws InterruptedException

      Waits for this future to be completed within the specified time limit.
      Returns:
        `true` if and only if the future was completed within the specified time limit
      Throws:
        `InterruptedException` - if the current thread was interrupted

    - #### awaitUninterruptibly

          boolean awaitUninterruptibly(long timeout,
                                     TimeUnit unit)

      Waits for this future to be completed within the specified time limit without interruption. This method catches an `InterruptedException` and discards it silently.
      Returns:
        `true` if and only if the future was completed within the specified time limit

    - #### awaitUninterruptibly

          boolean awaitUninterruptibly(long timeoutMillis)

      Waits for this future to be completed within the specified time limit without interruption. This method catches an `InterruptedException` and discards it silently.
      Returns:
        `true` if and only if the future was completed within the specified time limit

Copyright © 2008-2012 The Netty Project. All Rights Reserved.